//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>
#include <sysutils.hpp>
#include "myCV.h"
#include "cvQCodeBeacons.h"

#include "Unit2.h"

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

CvCapture* capture = 0; //Camera frame capture object
IplImage* image;

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //Get camera frame capture object
  capture=cvCaptureFromCAM(0);

  //Prepare buffer image
  CvSize sz; sz.width=320; sz.height=240;
  image = cvCreateImage( sz, 8, 3 );
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  if(!capture) return;

  IplImage* frame=cvQueryFrame( capture );

  if(!frame)return;

  cvResize(frame,image,CV_INTER_LINEAR);

  CvQCodeBeacon* b=mycvGetQCodeBeacons(image, 4);

  mycvShowImage(Image1,image);

  while(b!=NULL){
     int xx=b->bx;
     int yy=b->by;
     int x1=b->x1;
     int y1=b->y1;
     int x2=b->x2;
     int y2=b->y2;
     int id=b->id;
     int x=b->x;
     int y=b->y;
     b=b->next;

     Image1->Canvas->Pen->Color=clYellow;
     Image1->Canvas->MoveTo(xx,yy);
     Image1->Canvas->LineTo(xx+x1,yy+y1);
     Image1->Canvas->LineTo(xx+x1+x2,yy+y1+y2);
     Image1->Canvas->LineTo(xx+x2,yy+y2);
     Image1->Canvas->LineTo(xx,yy);
     Image1->Canvas->Font->Size=14;
     Image1->Canvas->Font->Color=clRed;
     int tw=Image1->Canvas->TextWidth("#"+IntToStr(id));
     int th=Image1->Canvas->TextHeight("#"+IntToStr(id));
     Image1->Canvas->TextOutA(x-tw/2,y-th/2,"#"+IntToStr(id));
  };
}


//---------------------------------------------------------------------------


void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  cvReleaseCapture(&capture);
  cvReleaseImage(&image);
}
//---------------------------------------------------------------------------

